Tweak test-docker-py feature

- move docker/docker-py clone to the Dockerfile
- put "integration test daemon startup" code in a separate file for both scripts to source
- add new test-docker-py Makefile target
- include "python-websocket" package in Dockerfile for running the tests

Signed-off-by: Andrew "Tianon" Page <admwiggin@gmail.com>
Upstream-commit: 100267de81985bbf3b976bfde850def89487dc11
Component: engine
This commit is contained in:
Tianon Gravi
2014-12-19 00:20:59 -07:00
parent da3465e509
commit 241c2f0465
7 changed files with 51 additions and 56 deletions

View File

@ -0,0 +1,24 @@
#!/bin/bash
# see test-integration-cli for example usage of this script
export PATH="$DEST/../binary:$DEST/../dynbinary:$PATH"
if ! command -v docker &> /dev/null; then
echo >&2 'error: binary or dynbinary must be run before .integration-daemon-start'
false
fi
# intentionally open a couple bogus file descriptors to help test that they get scrubbed in containers
exec 41>&1 42>&2
DOCKER_GRAPHDRIVER=${DOCKER_GRAPHDRIVER:-vfs}
DOCKER_EXECDRIVER=${DOCKER_EXECDRIVER:-native}
( set -x; exec \
docker --daemon --debug \
--storage-driver "$DOCKER_GRAPHDRIVER" \
--exec-driver "$DOCKER_EXECDRIVER" \
--pidfile "$DEST/docker.pid" \
&> "$DEST/docker.log"
) &

View File

@ -0,0 +1,7 @@
#!/bin/bash
for pid in $(find "$DEST" -name docker.pid); do
DOCKER_PID=$(set -x; cat "$pid")
( set -x; kill $DOCKER_PID )
wait $DOCKERD_PID || true
done

View File

@ -3,41 +3,20 @@ set -e
DEST=$1
DOCKER_GRAPHDRIVER=${DOCKER_GRAPHDRIVER:-vfs}
DOCKER_EXECDRIVER=${DOCKER_EXECDRIVER:-native}
# subshell so that we can export PATH without breaking other things
exec > >(tee -a $DEST/test.log) 2>&1
(
export PATH="$DEST/../binary:$DEST/../dynbinary:$PATH"
source "$(dirname "$BASH_SOURCE")/.integration-daemon-start"
if ! command -v docker &> /dev/null; then
echo >&2 'error: binary or dynbinary must be run before test-docker-py'
false
fi
dockerPy='/docker-py'
[ -d "$dockerPy" ] || {
dockerPy="$DEST/docker-py"
git clone https://github.com/docker/docker-py.git "$dockerPy"
}
# intentionally open a couple bogus file descriptors to help test that they get scrubbed in containers
exec 41>&1 42>&2
( set -x; exec \
docker --daemon --debug \
--storage-driver "$DOCKER_GRAPHDRIVER" \
--exec-driver "$DOCKER_EXECDRIVER" \
--pidfile "$DEST/docker.pid" \
&> "$DEST/docker.log"
) &
mkdir -p /tmp/dockerpy-tests && cd /tmp/dockerpy-tests
git clone https://github.com/docker/docker-py.git
cd docker-py
git checkout 0.6.0-integration
python setup.py install
cd "$dockerPy"
export PYTHONPATH=. # import "docker" from "."
python tests/integration_test.py
for pid in $(find "$DEST" -name docker.pid); do
DOCKER_PID=$(set -x; cat "$pid")
( set -x; kill $DOCKER_PID )
wait $DOCKERD_PID || true
done
source "$(dirname "$BASH_SOURCE")/.integration-daemon-stop"
)

View File

@ -3,9 +3,6 @@ set -e
DEST=$1
DOCKER_GRAPHDRIVER=${DOCKER_GRAPHDRIVER:-vfs}
DOCKER_EXECDRIVER=${DOCKER_EXECDRIVER:-native}
bundle_test_integration_cli() {
go_test_dir ./integration-cli
}
@ -13,23 +10,7 @@ bundle_test_integration_cli() {
# subshell so that we can export PATH without breaking other things
exec > >(tee -a $DEST/test.log) 2>&1
(
export PATH="$DEST/../binary:$DEST/../dynbinary:$PATH"
if ! command -v docker &> /dev/null; then
echo >&2 'error: binary or dynbinary must be run before test-integration-cli'
false
fi
# intentionally open a couple bogus file descriptors to help test that they get scrubbed in containers
exec 41>&1 42>&2
( set -x; exec \
docker --daemon --debug \
--storage-driver "$DOCKER_GRAPHDRIVER" \
--exec-driver "$DOCKER_EXECDRIVER" \
--pidfile "$DEST/docker.pid" \
&> "$DEST/docker.log"
) &
source "$(dirname "$BASH_SOURCE")/.integration-daemon-start"
# pull the busybox image before running the tests
sleep 2
@ -38,9 +19,5 @@ exec > >(tee -a $DEST/test.log) 2>&1
bundle_test_integration_cli
for pid in $(find "$DEST" -name docker.pid); do
DOCKER_PID=$(set -x; cat "$pid")
( set -x; kill $DOCKER_PID )
wait $DOCKERD_PID || true
done
source "$(dirname "$BASH_SOURCE")/.integration-daemon-stop"
)